CREATE OR REPLACE FUNCTION ARQUIVO_GIA_MS_05(
   P_CDEMPRESA   IN EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA  IN NOTAFISCAL.CDINSCESTA%TYPE,
   P_CDIMPOSTO   IN IMPOSTO.CDIMPOSTO%TYPE,
   P_DTINICIAL   IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL     IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_TPDEC       IN VARCHAR,
   P_PDEC        IN VARCHAR,
   P_CONTADOR    IN VARCHAR,
   P_SEQMAGNET   IN VARCHAR)

RETURN VARCHAR
AS
   V_CONTADOR            NUMBER;
   V_INSERT              VARCHAR2(500);
   V_MESINI              VARCHAR2(2);
   V_VRTRIBUTADO         NUMBER;
   V_VRISENTO            NUMBER;
   V_VRISENOUTROS        NUMBER;
   V_VRSUBSTRIB          NUMBER;
   V_TOTVRTRIBUTADO      NUMBER;
   V_TOTVRISENTO         NUMBER;
   V_TOTVRISENOUTROS     NUMBER;
   V_TOTVRSUBSTRIB       NUMBER;
   V_VRTRIBUTADOFIM      NUMBER;
   V_VRISENTOFIM         NUMBER;
   V_VRISENOUTROSFIM     NUMBER;
   V_VRSUBSTRIBFIM       NUMBER;
   V_TOTVRTRIBUTADOFIM   NUMBER;
   V_TOTVRISENTOFIM      NUMBER;
   V_TOTVRISENOUTROSFIM  NUMBER;
   V_TOTVRSUBSTRIBFIM    NUMBER;
   V_REGISTRO_03         VARCHAR2(500);
   V_DATAINICIAL         DATE;
   V_DATAFIM             DATE;

BEGIN

   V_VRTRIBUTADO         := 0;
   V_VRISENTO            := 0;
   V_VRISENOUTROS        := 0;
   V_VRSUBSTRIB          := 0;
   V_TOTVRTRIBUTADO      := 0;
   V_TOTVRISENTO         := 0;
   V_TOTVRSUBSTRIB       := 0;
   V_VRTRIBUTADOFIM      := 0;
   V_VRISENTOFIM         := 0;
   V_VRISENOUTROSFIM     := 0;
   V_VRSUBSTRIBFIM       := 0;
   V_TOTVRTRIBUTADOFIM   := 0;
   V_TOTVRISENTOFIM      := 0;
   V_TOTVRISENOUTROSFIM  := 0;
   V_TOTVRSUBSTRIBFIM    := 0;

   /* BUSCA O ANO ANTERIOR A DATA INFORMADA */
   V_DATAINICIAL := TO_DATE('01/01/'||ABS(1 - SUBSTR(P_DTINICIAL,7,10)));
   V_DATAFIM     := TO_DATE('31/12/'||ABS(1 - SUBSTR(P_DTFINAL,7,10)));


   V_CONTADOR   := NVL(P_CONTADOR,0);

   IF P_PDEC = '2' THEN
      V_MESINI := '00';
   ELSE
      V_MESINI := TO_CHAR(P_DTINICIAL,'MM');
   END IF;

   V_INSERT := SUBSTR(RPAD(REPLACE(REPLACE(REPLACE(NVL(P_CDINSCESTA, ' '),'.',''),'-',''),'ISENT','ISENTO'),9,' '),1,9)
               ||TO_CHAR(P_DTINICIAL,'YYYY')
               ||V_MESINI
               ||TO_CHAR(P_DTFINAL,'MM')
               ||P_TPDEC
               ||'05';

   /*BUSCA TODAS AS FILIAIS QUE UTILIZAM AQUELA INSCRIO ESTADUAL*/
/*  retirado por que estava duplicando os valores
   FOR C_FILIAL IN(
      SELECT F.CDFILIAL
        FROM FILIAL F
       WHERE F.CDEMPRESA = P_CDEMPRESA
         AND F.CDINSCESTA = P_CDINSCESTA
       ORDER BY CDFILIAL)  LOOP   */

        /*ESTOQUE INICIAL DOS PRODUTOS */
         BEGIN
           SELECT SUM(DECODE(CDFISCAL,'1',VRESTDIACON,0)),
                  SUM(DECODE(CDFISCAL,'2',VRESTDIACON,0)),
                  SUM(DECODE(CDFISCAL,'3',VRESTDIACON,0)),
                  SUM(DECODE(CDFISCAL,'T',VRESTDIACON,0))
             INTO V_VRTRIBUTADO,V_VRISENTO,V_VRISENOUTROS,V_VRSUBSTRIB
             FROM (SELECT I.VRTOTINVFISC AS VRESTDIACON,
                     CODIGO_FISCAL_PRODUTO_NFE('E',P_CDEMPRESA,P.CDPRODUTO,P_CDINSCESTA,'01',P_CDIMPOSTO) AS CDFISCAL
                FROM INVENTFISC I, PRODUTO P
                  WHERE I.CDEMPRESA    = P_CDEMPRESA
                    AND I.CDINSCESTA   = P_CDINSCESTA
                    AND I.DTINVEFISCAL <=V_DATAINICIAL
                    AND I.CDPRODUTO    = P.CDPRODUTO
                    AND I.QTESTINVFISC <> 0);
         EXCEPTION WHEN NO_DATA_FOUND THEN
             V_VRTRIBUTADO  := 0;
             V_VRISENTO     := 0;
             V_VRISENOUTROS := 0;
             V_VRSUBSTRIB   := 0;
         END;

         V_TOTVRTRIBUTADO  := V_TOTVRTRIBUTADO + NVL(V_VRTRIBUTADO,0);
         V_TOTVRISENTO     := V_TOTVRISENTO + NVL(V_VRISENTO,0);
         V_TOTVRISENOUTROS := V_TOTVRISENOUTROS + NVL(V_VRISENOUTROS,0);
         V_TOTVRSUBSTRIB   := V_TOTVRSUBSTRIB + NVL(V_VRSUBSTRIB,0);


         /*ESTOQUE FINAL DOS PRODUTOS */
         BEGIN
            SELECT SUM(DECODE(CDFISCAL,'1',VRESTDIACON,0)),
                   SUM(DECODE(CDFISCAL,'2',VRESTDIACON,0)),
                   SUM(DECODE(CDFISCAL,'3',VRESTDIACON,0)),
                   SUM(DECODE(CDFISCAL,'T',VRESTDIACON,0))
              INTO V_VRTRIBUTADOFIM,V_VRISENTOFIM,V_VRISENOUTROSFIM,V_VRSUBSTRIBFIM
              FROM (SELECT I.VRTOTINVFISC AS VRESTDIACON,
                     CODIGO_FISCAL_PRODUTO_NFE('E',P_CDEMPRESA,P.CDPRODUTO,P_CDINSCESTA,'01',P_CDIMPOSTO) AS CDFISCAL
                FROM INVENTFISC I, PRODUTO P
                  WHERE I.CDEMPRESA    = P_CDEMPRESA
                    AND I.CDINSCESTA   = P_CDINSCESTA
                    AND I.DTINVEFISCAL <= V_DATAFIM + 1
                    AND I.CDPRODUTO    = P.CDPRODUTO
                    AND I.QTESTINVFISC <> 0);

         EXCEPTION WHEN NO_DATA_FOUND THEN
             V_VRTRIBUTADOFIM  := 0;
             V_VRISENTOFIM     := 0;
             V_VRISENOUTROSFIM := 0;
             V_VRSUBSTRIBFIM   := 0;
         END;
         
         V_TOTVRTRIBUTADOFIM  := V_TOTVRTRIBUTADOFIM + NVL(V_VRTRIBUTADOFIM,0);
         V_TOTVRISENTOFIM     := V_TOTVRISENTOFIM + NVL(V_VRISENTOFIM,0);
         V_TOTVRISENOUTROSFIM := V_TOTVRISENOUTROSFIM + NVL(V_VRISENOUTROSFIM,0);
         V_TOTVRSUBSTRIBFIM   := V_TOTVRSUBSTRIBFIM + NVL(V_VRSUBSTRIBFIM,0);

  /*END LOOP; DA FILIAL */

   V_REGISTRO_03 := LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(V_TOTVRTRIBUTADO,0),2),'99999999990.00')),'.',''),13,'0')
                    ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(V_TOTVRISENTO,0),2),'99999999990.00')),'.',''),13,'0')
                    ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(V_TOTVRISENOUTROS,0),2),'99999999990.00')),'.',''),13,'0')
                    ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(V_TOTVRSUBSTRIB,0),2),'99999999990.00')),'.',''),13,'0')
                    ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(V_TOTVRTRIBUTADOFIM,0),2),'99999999990.00')),'.',''),13,'0')
                    ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(V_TOTVRISENTOFIM,0),2),'99999999990.00')),'.',''),13,'0')
                    ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(V_TOTVRISENOUTROSFIM,0),2),'99999999990.00')),'.',''),13,'0')
                    ||LPAD(REPLACE(LTRIM(TO_CHAR(ROUND(NVL(V_TOTVRSUBSTRIBFIM,0),2),'99999999990.00')),'.',''),13,'0');


   V_CONTADOR := NVL(V_CONTADOR,0)+1;
   INSERT INTO ARQMAGNETICO
      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
      (LPAD(V_CONTADOR, 10, '0'),V_INSERT||V_REGISTRO_03||LPAD(' ',479,' '),P_SEQMAGNET);

RETURN (TO_CHAR(LPAD(V_CONTADOR, 10, '0')));
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_GIA_MS_05','5.30.000'); END;
/

