/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ITMENUCONFTE                                             */
/* Tabela : ITMENUCONFTE                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 10/01/2005 - Wanderson Alosio                                             */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ITMENUCONFTE'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_ITMENUCONFTE
GO

CREATE TRIGGER DTULTATU_ITMENUCONFTE
ON ITMENUCONFTE
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'ITMENUCONFTE', CDFILIAL, 'CDFILIAL='+CDFILIAL+';'+
                'NRCONFTELA='+NRCONFTELA+';'+'IDTPBUTTON='+IDTPBUTTON+';'+
                'NRBUTTON='+NRBUTTON+';'+'NRPGCONFTELA='+NRPGCONFTELA+';'+
                'IDTPBUTONAUX='+IDTPBUTONAUX+';'+'NRBUTTONAUX='+NRBUTTONAUX+';'+
                'NRPGCONFTAUX='+NRPGCONFTAUX+';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)

      UPDATE PRODUTO
      SET DTULTATUPROD = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM DELETED
      WHERE CDPRODUTO  = ISNULL(DELETED.CDIDENTBUTON,0);

      UPDATE PRODOCORRE
      SET DTULTATUPOCO = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM DELETED
      WHERE CDPRODUTO  = ISNULL(DELETED.CDIDENTBUTON,0);

      UPDATE PRODLOJA
      SET DTULTATUPLOJ = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM DELETED
      WHERE CDPRODUTO  = ISNULL(DELETED.CDIDENTBUTON,0);

      UPDATE PRODUTOSEG
      SET DTULTATUPSEG = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM DELETED
      WHERE CDPRODUTO  = ISNULL(DELETED.CDIDENTBUTON,0);
   END
   ELSE BEGIN
      UPDATE ITMENUCONFTE
      SET DTULTATUITCT = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(ITMENUCONFTE.CDFILIAL,0)     = ISNULL(INSERTED.CDFILIAL,0))     AND
            (ISNULL(ITMENUCONFTE.NRCONFTELA,0)   = ISNULL(INSERTED.NRCONFTELA,0))   AND
            (ISNULL(ITMENUCONFTE.IDTPBUTTON,0)   = ISNULL(INSERTED.IDTPBUTTON,0))   AND
            (ISNULL(ITMENUCONFTE.NRBUTTON,0)     = ISNULL(INSERTED.NRBUTTON,0))     AND
            (ISNULL(ITMENUCONFTE.NRPGCONFTELA,0) = ISNULL(INSERTED.NRPGCONFTELA,0)) AND
            (ISNULL(ITMENUCONFTE.IDTPBUTONAUX,0) = ISNULL(INSERTED.IDTPBUTONAUX,0)) AND
            (ISNULL(ITMENUCONFTE.NRBUTTONAUX,0)  = ISNULL(INSERTED.NRBUTTONAUX,0))  AND
            (ISNULL(ITMENUCONFTE.NRPGCONFTAUX,0) = ISNULL(INSERTED.NRPGCONFTAUX,0))   ;

      UPDATE PRODUTO
      SET DTULTATUPROD = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE CDPRODUTO  = ISNULL(INSERTED.CDIDENTBUTON,0);

      UPDATE PRODOCORRE
      SET DTULTATUPOCO = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE CDPRODUTO  = ISNULL(INSERTED.CDIDENTBUTON,0);

      UPDATE PRODLOJA
      SET DTULTATUPLOJ = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE CDPRODUTO  = ISNULL(INSERTED.CDIDENTBUTON,0);

      UPDATE PRODUTOSEG
      SET DTULTATUPSEG = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE CDPRODUTO  = ISNULL(INSERTED.CDIDENTBUTON,0);
   END;
END;
GO

UPDATE ITMENUCONFTE SET DTULTATUITCT = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUITCT IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
               o.name = 'DEFAULT_DTULTATUITCT' and
            type = 'D')
   ALTER TABLE ITMENUCONFTE DROP CONSTRAINT DEFAULT_DTULTATUITCT
GO

ALTER TABLE ITMENUCONFTE ADD CONSTRAINT DEFAULT_DTULTATUITCT
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUITCT
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_ITMENUCONFTE','4.11.194';
GO


